#include <iostream>

using namespace std;

typedef struct 
{
  char typ;
} bludiste;

bludiste blud[100] [100];
int velx, vely;

struct prochazim;

extern prochazim pole[];

struct prochazim
{
  int pozice;
  prochazim *predchozi;
  char keys[4];
  int x, y;
  bool smim (int smerx, int smery)
  {
    if ((x + smerx < 0) || (x + smerx > velx)) return false;
    if ((y + smery < 0) || (y + smery > vely)) return false;
    char c = blud[x + smerx] [y + smery].typ;
    if (c == 'B' && !keys[0]) return false;
    if (c == 'Y' && !keys[1]) return false;
    if (c == 'R' && !keys[2]) return false;
    if (c == 'G' && !keys[3]) return false;
    if (blud[x + smerx] [y + smery].typ != '#') return true;
    return false;
  }
  bool byljsem ()
  {
    prochazim *pr = predchozi;
    for (int i = 0; i < pozice; i++)
    {
      if (pr->x == x && pr->y == y && memcmp(pr->keys,keys,sizeof(char)*4)) return true;
      pr = pr->predchozi;
    }
    return false;
  }
  int spawn(int smerx, int smery, int &nakonec)
  {
    if(smim(smerx, smery))
    {
      pole[nakonec].x = x + smerx;
      pole[nakonec].y = y + smery;
      pole[nakonec].predchozi = this;
      memcpy(pole[nakonec].keys, keys, 4*sizeof(char));
      pole[nakonec].pozice = pozice++;
      if(!pole[nakonec].byljsem())
        return -1;
      nakonec++;
      if(pole[nakonec-1].sezer())
      {
        return 1;
      }
      return 0;
    }
    return -1; 
  }
  bool sezer()
  {
    char b = blud[x][y].typ;
    if (b == 'X')
      return true;
    if (b == 'b')
    {
      keys[0] = 'b';
    }
    if (b == 'y')
    {
      keys[1] = 'y';
    }
    if (b == 'r')
    {
      keys[2] = 'r';
    }
    if (b == 'g')
    {
      keys[3] = 'g';
    }
    return false;
  }
};

prochazim pole [10000];

int main ()
{
  for (;;)
  {
    cin >> vely;
    cin.ignore(1);
    cin >> velx;
    cin.ignore(1);
    int stx, sty;
    if (!(velx + vely)) return 0;
    char c;
    bool mareseni = false;
    for (int i = 0; i < vely ; i++)
    {
      for (int j = 0; j < velx; j++)
      {
        cin.get (c);
        if (c == '*') 
        {
          stx = i;
          sty = j;
        }
        if (c == 'X')
        {
          mareseni = true;
        }
        blud[i] [j].typ = c;
      }
      cout << i; 
      //cin.ignore(1);
      
    }
    //prochazeni
    if (!mareseni){
      cout << "zase kurva" << endl;
      return 0;
    }
    bool konec = false;
    memset(pole,0,sizeof(prochazim)*10001);
    pole[0].pozice = 0;
    pole[0].predchozi = NULL;
    pole[0].keys[0] = 0;
    pole[0].keys[1] = 0;
    pole[0].keys[2] = 0;
    pole[0].keys[3] = 0;
    pole[0].x = stx;
    pole[0].y = sty;
    int x, y;
    int pozice = 0;
    int konecpole = 1;
    int kroky = 100000;
    while (!konec)
    {
      if(pole[konecpole].spawn(1, 0, konecpole) == 1)
      {
          if(pole[konecpole].pozice < kroky)
            kroky = pole[konecpole].pozice;
          konec = true;
          // nejak ulozit tu cestu
      }
    }
    if (!mareseni)
      cout << "kurvaaaaaaaaaaaaaaaaaaaaaaaaa" << endl;
  }
}
